# -*- coding: UTF-8 -*-
import addonHandler
addonHandler.initTranslation()

import os, sys, globalVars
def findConfigFile (configPath):
	fileList = os.listdir(configPath)
	for fileName in fileList:
		if "FirefoxAddon"  in fileName:
			return  fileName
	return None
	
def onInstall():
	import gui, wx,shutil
	#include the module directory to the path
	sys.path.append(os.path.dirname(__file__))
	# save old configuration
	userConfigPath = globalVars.appArgs.configPath
	addonConfigFile = findConfigFile(userConfigPath)
	if addonConfigFile:
		addonConfigPath = os.path.join(userConfigPath, addonConfigFile)
		if gui.messageBox(
			# Translators: the label of a message box dialog.
			_("Do you want to keep previous add-on configuration settings ?"),
			# Translators: the title of a message box dialog.
			_("Firefoxadd-on installation"),
			wx.YES|wx.NO|wx.ICON_WARNING)==wx.YES:
			dest = os.path.join(os.path.dirname(__file__).decode("mbcs"), addonConfigFile)
			try:
				shutil.copy(addonConfigPath, dest)
			except:
				pass
		
		os.remove(addonConfigPath )
		if os.path.exists(addonConfigPath):
			log.warning("Error on deletion of Firefox addon settings file")
			
	del sys.path[-1]
	

def onUninstall():
	import os
		# save old configuration
	userConfigPath = globalVars.appArgs.configPath
	addonConfigFile = findConfigFile(userConfigPath)
	if addonConfigFile:
		addonConfigPath = os.path.join(userConfigPath, addonConfigFile)
		os.remove(addonConfigPath )
		if os.path.exists(addonConfigPath):
			log.warning("Error on deletion of Firefox addon settings file")
	
